
clear all; close all;
n=40; h=2/n; x=-1:h:1; y=x;     % Domain: [-1, 1] x [-1, 1]

h2 = 2*h; h1 = h*h;
width_in=2*h; width_out=4*h; width3 = width_out+2*h;
width_in=10*h; width_out=11*h; width3 = width_out+2*h;
width_in=5*h; width_out=6*h; width3 = width_out+2*h;

%%%%% % Define a level set function for the geometry
%%
%%              x^2/0.5^2 + y^2/0.4^2 = 1,   an ellipse

for i=1:n+1,
  for j=1:n+1,
     phi(i,j) = sqrt( x(i)*x(i)/0.35^2 + y(j)*y(j)/0.5^2)-1; 
  end                                    
end

z=zeros(n+1,n+1); contour(x,y,phi,z);   axis('square')  % Plot the ellipse
haja = z; curv=z;

for k=1:250;

U_max = 0;

for i=1:n+1,
  for j=1:n+1,
    haja(i,j) = 0;
    tmp = abs(phi(i,j));
    if tmp < width_out
       [grad_l, grad_r] = eno2(n,n,i,j,phi,h,h);
%       U_n = -1;
	  U_n = -my_curv(n,n,i,j,phi,h,h);curv;
	  U_max = max( U_max, abs(U_n) );
       U_n = U_n* cut_off(tmp,width_in, width_out);
      haja(i,j) = max(U_n,0)*grad_r + min(U_n,0)*grad_l;
    end
  end
end

%dt = 0.25*h/max(max(abs(curv)));
 dt = 0.5*h/U_max;

for i=1:n+1,
  for j=1:n+1,
    tmp = abs(phi(i,j));
    if tmp < width_out
     phi(i,j) = phi(i,j) - dt*haja(i,j);
    end
  end
end

   phi = reinit(n,n,h,h,phi,width3);
   phi = reinit(n,n,h,h,phi,width3);


contour(x,y,phi,z); axis('square')
pause(1)

end


