
function curv =curvature(m,n,i,j,h,x,y,phi)

  h1 = h*h;
  if i == 1
     il = i;
     ir = i+2;
     ic = i+1;
  else
     if i==m+1
	il = i-2;
        ir = i;
        ic = i-1;
     else
        il = i-1;
        ir = i+1;
        ic = i;
     end
  end

  if j == 1
     jl = j;
     jr = j+2;
     jc = j+1;
  else
     if j==n+1
        jl = j-2;
        jr = j;
        jc = j-1;
     else
        jl = j-1;
        jr = j+1;
        jc = j;
     end
  end

  px = (phi(ir,j)-phi(il,j) )/(2*h);
  pxx = (phi(il,j)+phi(ir,j)-2*phi(ic,j))/h1;

  py = (phi(i,jr)-phi(i,jl))/(2*h);
  pyy = (phi(i,jr)+phi(i,jl)-2*phi(i,jc))/h1;

  phn = sqrt( px^2+py^2);
  pxy = (phi(ir,jr)+phi(il,jl)-phi(ir,jl)-phi(il,jr))/(4*h1);

  curv = (pxx*py*py-2*pxy*px*py+px*px*pyy)/( (phn+1e-10)^3); 

