
function [grad_l, grad_r] = eno2(m,n,i,j,phi,dx,dy)

	[dxl,dxr] = eno2x(m,n,i,j,phi,dx);
        [dyl,dyr] = eno2y(m,n,i,j,phi,dy);

	A = dxl;   B = dxr;
	C = dyl;   D = dyr;

	grad_r = sqrt( max(A,0)*max(A,0) + min(B,0)*min(B,0) + ...
                       max(C,0)*max(C,0) + min(D,0)*min(D,0) );

	grad_l = sqrt(max(B,0)*max(B,0) + min(A,0)*min(A,0) + ...
                       max(D,0)*max(D,0) + min(C,0)*min(C,0) );
